// Generated by CoffeeScript 1.8.0
(function() {
  var components, minRegex, named, number, parse, rangeRegex, _;

  _ = require('lodash');

  named = require('named-regexp').named;

  number = require('./number');

  minRegex = named(/(:<min>\d+(?:\.\d+)?)\s*\+/);

  rangeRegex = named(/(:<min>\d+(?:\.\d+)?)\s+(:<max>\d+(?:\.\d+)?)/);

  parse = function(string) {
    var captures, match, max, min, num, parsed, sanitized, _ref, _ref1;
    if (string == null) {
      return string;
    }
    sanitized = string.replace(/-|(?:to)/, ' ').replace(/[^0-9 .+]/g, '');
    match = minRegex.exec(sanitized) || rangeRegex.exec(sanitized);
    if (match) {
      captures = match.captures;
      min = (((_ref = captures.min) != null ? _ref[0] : void 0) != null) && parseFloat(captures.min[0]);
      max = (((_ref1 = captures.max) != null ? _ref1[0] : void 0) != null) && parseFloat(captures.max[0]);
      if (_(min).isNumber() && _(max).isNumber()) {
        parsed = new String("" + min + "-" + max);
        parsed.raw = string;
        parsed.avg = ((min + max) / 2).toFixed(2);
        parsed.min = min;
        parsed.max = max;
      } else if (_(min).isNumber()) {
        parsed = new String("" + min + "+");
        parsed.raw = string;
        parsed.avg = null;
        parsed.min = min;
        parsed.max = null;
      } else {
        parsed = new String(string);
        parsed.raw = string;
        parsed.valid = false;
      }
    } else {
      num = number.parse(string);
      parsed = new String(string);
      parsed.raw = string;
      parsed.min = (num != null ? num.valueOf() : void 0) || null;
      parsed.max = (num != null ? num.valueOf() : void 0) || null;
      parsed.avg = (num != null ? num.valueOf() : void 0) || null;
      parsed.valid = num.valid;
    }
    if (parsed.valid == null) {
      parsed.valid = true;
    }
    return parsed;
  };

  components = [
    {
      name: 'raw',
      type: 'string',
      description: 'Unmodified value'
    }, {
      name: 'normal',
      type: 'number',
      description: 'Average of max and min, rounded down to the nearest integer'
    }, {
      name: 'max',
      type: 'number',
      description: 'Range maximum'
    }, {
      name: 'min',
      type: 'number',
      description: 'Range minimum'
    }, {
      name: 'avg',
      type: 'number',
      description: 'Range average'
    }
  ];

  module.exports = {
    parse: parse,
    components: components,
    maskable: false
  };

}).call(this);
